Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/ScatterSearchMainLoop.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/ScatterSearchMainLoop.cs	(revision 7785)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/ScatterSearchMainLoop.cs	(revision 7786)
@@ -41,16 +41,34 @@
       get { return (IValueLookupParameter<IMultiAnalyzer>)Parameters["Analyzer"]; }
     }
+    public IValueLookupParameter<DoubleValue> BestKnownQualityParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["BestKnownQuality"]; }
+    }
     public IValueLookupParameter<ICrossover> CrossoverParameter {
       get { return (IValueLookupParameter<ICrossover>)Parameters["Crossover"]; }
     }
-    public IValueLookupParameter<IOperator> ImproverParameter {
-      get { return (IValueLookupParameter<IOperator>)Parameters["Improver"]; }
-    }
-    public IValueLookupParameter<DiversityCalculator> DiversityCalculatorParameter {
-      get { return (IValueLookupParameter<DiversityCalculator>)Parameters["DiversityCalculator"]; }
+    public IValueLookupParameter<IEvaluator> EvaluatorParameter {
+      get { return (IValueLookupParameter<IEvaluator>)Parameters["Evaluator"]; }
+    }
+    public IValueLookupParameter<BoolValue> ExecutePathRelinkingParameter {
+      get { return (IValueLookupParameter<BoolValue>)Parameters["ExecutePathRelinking"]; }
+    }
+    public IValueLookupParameter<IImprovementOperator> ImproverParameter {
+      get { return (IValueLookupParameter<IImprovementOperator>)Parameters["Improver"]; }
+    }
+    public IValueLookupParameter<IntValue> IterationsParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["Iterations"]; }
+    }
+    public IValueLookupParameter<BoolValue> MaximizationParameter {
+      get { return (IValueLookupParameter<BoolValue>)Parameters["Maximization"]; }
+    }
+    public IValueLookupParameter<IntValue> MaximumIterationsParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["MaximumIterations"]; }
     }
     public IValueLookupParameter<IntValue> NumberOfHighQualitySolutionsParameter {
       get { return (IValueLookupParameter<IntValue>)Parameters["NumberOfHighQualitySolutions"]; }
     }
+    public IValueLookupParameter<IPathRelinker> PathRelinkerParameter {
+      get { return (IValueLookupParameter<IPathRelinker>)Parameters["PathRelinker"]; }
+    }
     public IValueLookupParameter<IntValue> PopulationSizeParameter {
       get { return (IValueLookupParameter<IntValue>)Parameters["PopulationSize"]; }
@@ -59,19 +77,4 @@
       get { return (IValueLookupParameter<IntValue>)Parameters["ReferenceSetSize"]; }
     }
-    public IValueLookupParameter<DoubleValue> BestKnownQualityParameter {
-      get { return (IValueLookupParameter<DoubleValue>)Parameters["BestKnownQuality"]; }
-    }
-    public IValueLookupParameter<IEvaluator> EvaluatorParameter {
-      get { return (IValueLookupParameter<IEvaluator>)Parameters["Evaluator"]; }
-    }
-    public IValueLookupParameter<IntValue> IterationsParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["Iterations"]; }
-    }
-    public IValueLookupParameter<BoolValue> MaximizationParameter {
-      get { return (IValueLookupParameter<BoolValue>)Parameters["Maximization"]; }
-    }
-    public IValueLookupParameter<IntValue> MaximumIterationsParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["MaximumIterations"]; }
-    }
     public IValueLookupParameter<DoubleValue> QualityParameter {
       get { return (IValueLookupParameter<DoubleValue>)Parameters["Quality"]; }
@@ -83,6 +86,6 @@
       get { return (IValueLookupParameter<VariableCollection>)Parameters["Results"]; }
     }
-    public IValueLookupParameter<IntValue> SampleSizeParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["SampleSize"]; }
+    public IValueLookupParameter<SimilarityCalculator> SimilarityCalculatorParameter {
+      get { return (IValueLookupParameter<SimilarityCalculator>)Parameters["SimilarityCalculator"]; }
     }
     public IValueLookupParameter<ISolutionCreator> SolutionCreatorParameter {
@@ -96,15 +99,35 @@
       set { AnalyzerParameter.ActualValue = value; }
     }
+    private DoubleValue BestKnownQuality {
+      get { return BestKnownQualityParameter.ActualValue; }
+      set { BestKnownQualityParameter.ActualValue = value; }
+    }
     private ICrossover Crossover {
       get { return CrossoverParameter.ActualValue; }
       set { CrossoverParameter.ActualValue = value; }
     }
-    private IOperator Improver {
+    private IEvaluator Evaluator {
+      get { return EvaluatorParameter.ActualValue; }
+      set { EvaluatorParameter.ActualValue = value; }
+    }
+    private BoolValue ExecutePathRelinking {
+      get { return ExecutePathRelinkingParameter.ActualValue; }
+      set { ExecutePathRelinkingParameter.ActualValue = value; }
+    }
+    private IImprovementOperator Improver {
       get { return ImproverParameter.ActualValue; }
       set { ImproverParameter.ActualValue = value; }
     }
-    private DiversityCalculator DiversityCalculator {
-      get { return DiversityCalculatorParameter.ActualValue; }
-      set { DiversityCalculatorParameter.ActualValue = value; }
+    private IntValue Iterations {
+      get { return IterationsParameter.ActualValue; }
+      set { IterationsParameter.ActualValue = value; }
+    }
+    private BoolValue Maximization {
+      get { return MaximizationParameter.ActualValue; }
+      set { MaximizationParameter.ActualValue = value; }
+    }
+    private IntValue MaximumIterations {
+      get { return MaximumIterationsParameter.ActualValue; }
+      set { MaximumIterationsParameter.ActualValue = value; }
     }
     private IntValue NumberOfHighQualitySolutions {
@@ -112,4 +135,8 @@
       set { NumberOfHighQualitySolutionsParameter.ActualValue = value; }
     }
+    private IPathRelinker PathRelinker {
+      get { return PathRelinkerParameter.ActualValue; }
+      set { PathRelinkerParameter.ActualValue = value; }
+    }
     private IntValue PopulationSize {
       get { return PopulationSizeParameter.ActualValue; }
@@ -120,24 +147,4 @@
       set { ReferenceSetSizeParameter.ActualValue = value; }
     }
-    private DoubleValue BestKnownQuality {
-      get { return BestKnownQualityParameter.ActualValue; }
-      set { BestKnownQualityParameter.ActualValue = value; }
-    }
-    private IEvaluator Evaluator {
-      get { return EvaluatorParameter.ActualValue; }
-      set { EvaluatorParameter.ActualValue = value; }
-    }
-    private IntValue Iterations {
-      get { return IterationsParameter.ActualValue; }
-      set { IterationsParameter.ActualValue = value; }
-    }
-    private BoolValue Maximization {
-      get { return MaximizationParameter.ActualValue; }
-      set { MaximizationParameter.ActualValue = value; }
-    }
-    private IntValue MaximumIterations {
-      get { return MaximumIterationsParameter.ActualValue; }
-      set { MaximumIterationsParameter.ActualValue = value; }
-    }
     private DoubleValue Quality {
       get { return QualityParameter.ActualValue; }
@@ -152,7 +159,7 @@
       set { ResultsParameter.ActualValue = value; }
     }
-    private IntValue SampleSize {
-      get { return SampleSizeParameter.ActualValue; }
-      set { SampleSizeParameter.ActualValue = value; }
+    private SimilarityCalculator SimilarityCalculator {
+      get { return SimilarityCalculatorParameter.ActualValue; }
+      set { SimilarityCalculatorParameter.ActualValue = value; }
     }
     private ISolutionCreator SolutionCreator {
@@ -173,43 +180,45 @@
     private void Initialize() {
       #region Create parameters
-      Parameters.Add(new ValueLookupParameter<IMultiAnalyzer>("Analyzer", "The operator used to analyze the solution and moves."));
-      Parameters.Add(new ValueLookupParameter<ICrossover>("Crossover", "The operator used to combine solutions."));
-      Parameters.Add(new ValueLookupParameter<IOperator>("Improver", "The operator used to improve solutions."));
-      Parameters.Add(new ValueLookupParameter<DiversityCalculator>("DiversityCalculator", "The operator used to calculate the diversity of two solutions."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("NumberOfHighQualitySolutions", "The number of high quality solutions that should be added to the reference set."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("PopulationSize", "The size of the population."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("ReferenceSetSize", "The size of the reference set."));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("BestKnownQuality", "The problem's best known quality value found so far."));
-      Parameters.Add(new ValueLookupParameter<IEvaluator>("Evaluator", "The operator which is used to evaluate new solutions."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("Iterations", "The number of iterations performed."));
-      Parameters.Add(new ValueLookupParameter<BoolValue>("Maximization", "True if the problem is a maximization problem, otherwise false."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("MaximumIterations", "The maximum number of generations which should be processed."));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("Quality", "The value which represents the quality of a solution."));
-      Parameters.Add(new ValueLookupParameter<IRandom>("Random", "A pseudo random number generator."));
-      Parameters.Add(new ValueLookupParameter<VariableCollection>("Results", "The variable collection where results should be stored."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("SampleSize", "Number of moves that MultiMoveGenerators should create. This is ignored for Exhaustive- and SingleMoveGenerators."));
-      Parameters.Add(new ValueLookupParameter<ISolutionCreator>("SolutionCreator", "The operator which is used to create new solutions."));
+      Parameters.Add(new ValueLookupParameter<IMultiAnalyzer>("Analyzer"));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("BestKnownQuality"));
+      Parameters.Add(new ValueLookupParameter<ICrossover>("Crossover"));
+      Parameters.Add(new ValueLookupParameter<IEvaluator>("Evaluator"));
+      Parameters.Add(new ValueLookupParameter<BoolValue>("ExecutePathRelinking"));
+      Parameters.Add(new ValueLookupParameter<IOperator>("Improver"));
+      Parameters.Add(new ValueLookupParameter<IntValue>("Iterations"));
+      Parameters.Add(new ValueLookupParameter<BoolValue>("Maximization"));
+      Parameters.Add(new ValueLookupParameter<IntValue>("MaximumIterations"));
+      Parameters.Add(new ValueLookupParameter<IntValue>("NumberOfHighQualitySolutions"));
+      Parameters.Add(new ValueLookupParameter<IPathRelinker>("PathRelinker"));
+      Parameters.Add(new ValueLookupParameter<IntValue>("PopulationSize"));
+      Parameters.Add(new ValueLookupParameter<IntValue>("ReferenceSetSize"));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("Quality"));
+      Parameters.Add(new ValueLookupParameter<IRandom>("Random"));
+      Parameters.Add(new ValueLookupParameter<VariableCollection>("Results"));
+      Parameters.Add(new ValueLookupParameter<SimilarityCalculator>("SimilarityCalculator"));
+      Parameters.Add(new ValueLookupParameter<ISolutionCreator>("SolutionCreator"));
       #endregion
 
       #region Create operators
+      Placeholder analyzer = new Placeholder();
       Assigner assigner1 = new Assigner();
       Assigner assigner2 = new Assigner();
       ChildrenCreator childrenCreator = new ChildrenCreator();
+      Placeholder crossover = new Placeholder();
       Comparator iterationsChecker = new Comparator();
+      IntCounter iterationsCounter = new IntCounter();
+      MergingReducer mergingReducer = new MergingReducer();
+      ConditionalBranch executePathRelinkingBranch = new ConditionalBranch();
       ConditionalBranch newSolutionsBranch = new ConditionalBranch();
-      ConditionalBranch terminateBranch = new ConditionalBranch();
-      IntCounter interationsCounter = new IntCounter();
-      MergingReducer mergingReducer = new MergingReducer();
       OffspringProcessor offspringProcessor = new OffspringProcessor();
-      Placeholder analyzer = new Placeholder();
-      Placeholder crossover = new Placeholder();
+      Placeholder pathRelinker = new Placeholder();
+      PopulationRebuildMethod populationRebuildMethod = new PopulationRebuildMethod();
+      ReferenceSetUpdateMethod referenceSetUpdateMethod = new ReferenceSetUpdateMethod();
+      ResultsCollector resultsCollector = new ResultsCollector();
+      RightSelector rightSelector = new RightSelector();
       Placeholder solutionEvaluator1 = new Placeholder();
       Placeholder solutionEvaluator2 = new Placeholder();
       Placeholder solutionImprover1 = new Placeholder();
       Placeholder solutionImprover2 = new Placeholder();
-      PopulationRebuildMethod populationRebuildMethod = new PopulationRebuildMethod();
-      ResultsCollector resultsCollector = new ResultsCollector();
-      ReferenceSetUpdateMethod referenceSetUpdateMethod = new ReferenceSetUpdateMethod();
-      RightSelector rightSelector = new RightSelector();
       SolutionPoolUpdateMethod solutionPoolUpdateMethod = new SolutionPoolUpdateMethod();
       SolutionsCreator solutionsCreator = new SolutionsCreator();
@@ -217,24 +226,21 @@
       SubScopesProcessor subScopesProcessor2 = new SubScopesProcessor();
       SubScopesProcessor subScopesProcessor3 = new SubScopesProcessor();
+      ConditionalBranch terminateBranch = new ConditionalBranch();
       UniformSubScopesProcessor uniformSubScopesProcessor1 = new UniformSubScopesProcessor();
       UniformSubScopesProcessor uniformSubScopesProcessor2 = new UniformSubScopesProcessor();
       UniformSubScopesProcessor uniformSubScopesProcessor3 = new UniformSubScopesProcessor();
+      VariableCreator variableCreator = new VariableCreator();
       #endregion
 
       #region Create operator graph
-      OperatorGraph.InitialOperator = interationsCounter;
-      assigner1.Name = "NewSolutions = true";
-      assigner1.LeftSideParameter.ActualName = "NewSolutions";
-      assigner1.RightSideParameter.Value = new BoolValue(true);
-      assigner1.Successor = newSolutionsBranch;
-
-      assigner2.Name = "NewSolutions = false";
-      assigner2.LeftSideParameter.ActualName = "NewSolutions";
-      assigner2.RightSideParameter.Value = new BoolValue(false);
-      assigner2.Successor = uniformSubScopesProcessor1;
-
-      childrenCreator.Name = "SubsetGenerator";
-      childrenCreator.ParentsPerChildParameter.Value = new IntValue(2);
-      childrenCreator.Successor = assigner2;
+      OperatorGraph.InitialOperator = variableCreator;
+      variableCreator.CollectedValues.Add(new ValueParameter<IntValue>("Iterations", new IntValue(0)));
+      variableCreator.CollectedValues.Add(new ValueParameter<BoolValue>("NewSolutions", new BoolValue(false)));
+      variableCreator.Successor = resultsCollector;
+
+      resultsCollector.CopyValue = new BoolValue(false);
+      resultsCollector.CollectedValues.Add(new LookupParameter<IntValue>(IterationsParameter.Name));
+      resultsCollector.ResultsParameter.ActualName = ResultsParameter.Name;
+      resultsCollector.Successor = iterationsChecker;
 
       iterationsChecker.Name = "IterationsChecker";
@@ -245,65 +251,14 @@
       iterationsChecker.Successor = terminateBranch;
 
-      solutionImprover2.Name = "SolutionImprover";
-      solutionImprover2.OperatorParameter.ActualName = "Improver";
-      solutionImprover2.Successor = solutionEvaluator2;
-
-      solutionEvaluator2.Name = "SolutionEvaluator";
-      solutionEvaluator2.OperatorParameter.ActualName = "Evaluator";
-      solutionEvaluator2.Successor = null;
-
-      newSolutionsBranch.Name = "NewSolutionChecker";
-      newSolutionsBranch.ConditionParameter.ActualName = "NewSolutions";
-      newSolutionsBranch.TrueBranch = subScopesProcessor1;
-      newSolutionsBranch.FalseBranch = populationRebuildMethod;
-      newSolutionsBranch.Successor = null;
-
       terminateBranch.Name = "TerminateChecker";
       terminateBranch.ConditionParameter.ActualName = "Terminate";
-      terminateBranch.TrueBranch = new EmptyOperator();
       terminateBranch.FalseBranch = referenceSetUpdateMethod;
-      terminateBranch.Successor = null;
-
-      interationsCounter.Name = "IterationCounter";
-      interationsCounter.IncrementParameter.Value = new IntValue(1);
-      interationsCounter.ValueParameter.ActualName = "Iterations";
-      interationsCounter.Successor = resultsCollector;
-
-      offspringProcessor.Successor = rightSelector;
-
-      rightSelector.NumberOfSelectedSubScopesParameter.Value = new IntValue(1);
-      rightSelector.CopySelected = new BoolValue(false);
-      rightSelector.Successor = subScopesProcessor2;
-
-      analyzer.Name = "Analyzer";
-      analyzer.OperatorParameter.ActualName = "Analyzer";
-
-      crossover.Name = "Crossover";
-      crossover.OperatorParameter.ActualName = "Crossover";
-      crossover.Successor = offspringProcessor;
-
-      solutionImprover1.Name = "SolutionImprover";
-      solutionImprover1.OperatorParameter.ActualName = "Improver";
-      solutionImprover1.Successor = solutionEvaluator1;
-
-      solutionEvaluator1.Name = "SolutionEvaluator";
-      solutionEvaluator1.OperatorParameter.ActualName = "Evaluator";
-      solutionEvaluator1.Successor = null;
-
-      populationRebuildMethod.Successor = subScopesProcessor3;
-
-      resultsCollector.CopyValue = new BoolValue(false);
-      resultsCollector.CollectedValues.Add(new LookupParameter<IntValue>(IterationsParameter.Name));
-      resultsCollector.CollectedValues.Add(new LookupParameter<DoubleValue>(BestKnownQualityParameter.Name, null, BestKnownQualityParameter.Name));
-      resultsCollector.ResultsParameter.ActualName = ResultsParameter.Name;
-      resultsCollector.Successor = iterationsChecker;
 
       referenceSetUpdateMethod.Successor = assigner1;
 
-      solutionPoolUpdateMethod.Successor = analyzer;
-
-      solutionsCreator.Name = "DiversificationGenerationMethod";
-      solutionsCreator.NumberOfSolutionsParameter.ActualName = "PopulationSize";
-      solutionsCreator.Successor = uniformSubScopesProcessor3;
+      assigner1.Name = "NewSolutions = true";
+      assigner1.LeftSideParameter.ActualName = "NewSolutions";
+      assigner1.RightSideParameter.Value = new BoolValue(true);
+      assigner1.Successor = subScopesProcessor1;
 
       subScopesProcessor1.DepthParameter.Value = new IntValue(1);
@@ -312,4 +267,36 @@
       subScopesProcessor1.Successor = newSolutionsBranch;
 
+      childrenCreator.Name = "SubsetGenerator";
+      childrenCreator.ParentsPerChildParameter.Value = new IntValue(2);
+      childrenCreator.Successor = assigner2;
+
+      assigner2.Name = "NewSolutions = false";
+      assigner2.LeftSideParameter.ActualName = "NewSolutions";
+      assigner2.RightSideParameter.Value = new BoolValue(false);
+      assigner2.Successor = uniformSubScopesProcessor1;
+
+      uniformSubScopesProcessor1.DepthParameter.Value = new IntValue(1);
+      uniformSubScopesProcessor1.Operator = executePathRelinkingBranch;
+      uniformSubScopesProcessor1.Successor = solutionPoolUpdateMethod;
+
+      executePathRelinkingBranch.Name = "ExecutePathRelinkingChecker";
+      executePathRelinkingBranch.ConditionParameter.ActualName = ExecutePathRelinkingParameter.ActualName;
+      executePathRelinkingBranch.TrueBranch = pathRelinker;
+      executePathRelinkingBranch.FalseBranch = crossover;
+
+      pathRelinker.Name = "PathRelinker";
+      pathRelinker.OperatorParameter.ActualName = "PathRelinker";
+      pathRelinker.Successor = offspringProcessor;
+
+      crossover.Name = "Crossover";
+      crossover.OperatorParameter.ActualName = "Crossover";
+      crossover.Successor = offspringProcessor;
+
+      offspringProcessor.Successor = rightSelector;
+
+      rightSelector.NumberOfSelectedSubScopesParameter.Value = new IntValue(1);
+      rightSelector.CopySelected = new BoolValue(false);
+      rightSelector.Successor = subScopesProcessor2;
+
       subScopesProcessor2.DepthParameter.Value = new IntValue(1);
       subScopesProcessor2.Operators.Add(new EmptyOperator());
@@ -317,20 +304,49 @@
       subScopesProcessor2.Successor = mergingReducer;
 
+      uniformSubScopesProcessor2.DepthParameter.Value = new IntValue(2);
+      uniformSubScopesProcessor2.Operator = solutionImprover1;
+
+      solutionImprover1.Name = "SolutionImprover";
+      solutionImprover1.OperatorParameter.ActualName = "Improver";
+      solutionImprover1.Successor = solutionEvaluator1;
+
+      solutionEvaluator1.Name = "SolutionEvaluator";
+      solutionEvaluator1.OperatorParameter.ActualName = "Evaluator";
+
+      solutionPoolUpdateMethod.Successor = analyzer;
+
+      analyzer.Name = "Analyzer";
+      analyzer.OperatorParameter.ActualName = "Analyzer";
+
+      newSolutionsBranch.Name = "NewSolutionsChecker";
+      newSolutionsBranch.ConditionParameter.ActualName = "NewSolutions";
+      newSolutionsBranch.TrueBranch = subScopesProcessor1;
+      newSolutionsBranch.FalseBranch = populationRebuildMethod;
+
+      populationRebuildMethod.Successor = subScopesProcessor3;
+
       subScopesProcessor3.DepthParameter.Value = new IntValue(1);
       subScopesProcessor3.Operators.Add(solutionsCreator);
       subScopesProcessor3.Operators.Add(new EmptyOperator());
-      subScopesProcessor3.Successor = interationsCounter;
-
-      uniformSubScopesProcessor1.DepthParameter.Value = new IntValue(1);
-      uniformSubScopesProcessor1.Operator = crossover;
-      uniformSubScopesProcessor1.Successor = solutionPoolUpdateMethod;
-
-      uniformSubScopesProcessor2.DepthParameter.Value = new IntValue(2);
-      uniformSubScopesProcessor2.Operator = solutionImprover1;
-      uniformSubScopesProcessor2.Successor = null;
+      subScopesProcessor3.Successor = iterationsCounter;
+
+      solutionsCreator.Name = "DiversificationGenerationMethod";
+      solutionsCreator.NumberOfSolutionsParameter.ActualName = "PopulationSize";
+      solutionsCreator.Successor = uniformSubScopesProcessor3;
 
       uniformSubScopesProcessor3.DepthParameter.Value = new IntValue(1);
       uniformSubScopesProcessor3.Operator = solutionImprover2;
-      uniformSubScopesProcessor3.Successor = null;
+
+      solutionImprover2.Name = "SolutionImprover";
+      solutionImprover2.OperatorParameter.ActualName = "Improver";
+      solutionImprover2.Successor = solutionEvaluator2;
+
+      solutionEvaluator2.Name = "SolutionEvaluator";
+      solutionEvaluator2.OperatorParameter.ActualName = "Evaluator";
+
+      iterationsCounter.Name = "IterationCounter";
+      iterationsCounter.IncrementParameter.Value = new IntValue(1);
+      iterationsCounter.ValueParameter.ActualName = "Iterations";
+      iterationsCounter.Successor = resultsCollector;
       #endregion
     }
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/SimilarityCalculator.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/SimilarityCalculator.cs	(revision 7786)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/SimilarityCalculator.cs	(revision 7786)
@@ -0,0 +1,54 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.ScatterSearch {
+  /// <summary>
+  /// A base class for operators that perform diversity calculation between two solutions.
+  /// </summary>
+  [Item("DiversityCalculator", "A base class for operators that perform diversity calculation between two solutions.")]
+  [StorableClass]
+  public abstract class SimilarityCalculator : SingleSuccessorOperator {
+    [StorableConstructor]
+    protected SimilarityCalculator(bool deserializing) : base(deserializing) { }
+    protected SimilarityCalculator(SimilarityCalculator original, Cloner cloner) : base(original, cloner) { }
+    protected SimilarityCalculator() : base() { }
+
+    public sealed override IOperation Apply() { // TODO: check if sealed fits here?
+      return base.Apply();
+    }
+
+    public double ExecuteCalculation(IScope left, IScope right) {
+      if (left == null || right == null)
+        throw new ArgumentException("Cannot calculate diversity because one or both of the provided scopes is null.");
+
+      if (left == right) return 0;
+      else return CalculateDiversity(left, right);
+    }
+
+    protected abstract double CalculateDiversity(IScope left, IScope right);
+  }
+}
